
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <malloc.h>

int reverse;

int process_file(const char * filename)
{
    int fd;
    char * buffer;
    struct stat st;
    int status;
    int nest;
    int inside, skipping;
    int file_open;
    int linelen;
    char * ptr;

    fd = open(filename, O_RDONLY);
    if( fd == -1 ) return -1;
    status = fstat(fd, &st);
    if( status == -1 ) return -2;
    buffer = malloc(st.st_size);
    status = read(fd, buffer, st.st_size);
    if( status == -1 ) return -3;
    close(fd);

    /*
     * Now scan the darned thing and scrape out the gunk we don't want.
     */
    inside = 0;
    skipping = 0;
    file_open     = 0;
    nest = 0;
    ptr = buffer;
    while(ptr < buffer + st.st_size)
    {
	linelen = strchr(ptr, '\n') - ptr + 1;
	if( strncmp(ptr, "#ifdef CONFIG_SCSI_NEW_QUEUES\n", 30) == 0 )
	{
	    skipping = !reverse;
	    inside = 1;
	}
	else if( strncmp(ptr, "#ifndef CONFIG_SCSI_NEW_QUEUES\n", 31) == 0 )
	{
	    skipping = reverse;
	    inside = 1;
	}
	else if (inside && strncmp(ptr, "#if", 3) == 0 )
	{
	    nest++;
	    if( file_open && !skipping )
	    {
		write(fd, ptr, linelen);
	    }
	}
	else if( inside && nest == 0 && strncmp(ptr, "#else\n", 6) == 0 )
	{
	    skipping = !skipping;
	}
	else if( inside && strncmp(ptr, "#endif\n", 7) == 0 )
	{
	    if( nest == 0 )
	    {
		inside = 0;
		skipping = 0;
	    }
	    else
	    {
		nest--;
		if( file_open && !skipping )
		{
		    write(fd, ptr, linelen);
		}
	    }
	}
	else
	{
	    if( file_open && !skipping )
	    {
		write(fd, ptr, linelen);
	    }
	}
	if( inside && file_open == 0 )
	{
	    unlink(filename);
	    fd = open(filename, O_RDWR | O_CREAT, st.st_mode);
	    write(fd, buffer, ptr - buffer);
	    file_open = 1;
	}
	ptr += linelen;
    }
    if( file_open )
    {
	close(fd);
    }
    free(buffer);
    return 0;
}

main(int argc, char * argv[])
{
    int i;
    int nextarg = 1;
    int sts;

    reverse = 0;
    if( strcmp(argv[nextarg], "-R") == 0 )
    {
	nextarg++;
	reverse = 1;
    }

    for(i = nextarg; i < argc; i++)
    {
	sts = process_file(argv[i]);
	if( sts != 0 )
	{
	    printf("Failed to process %s (%d)\n", argv[i], sts);
	}
    }
}
